/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumberish,
  BytesLike,
  FunctionFragment,
  Result,
  Interface,
  EventFragment,
  AddressLike,
  ContractRunner,
  ContractMethod,
  Listener,
} from "ethers";
import type {
  TypedContractEvent,
  TypedDeferredTopicFilter,
  TypedEventLog,
  TypedLogDescription,
  TypedListener,
  TypedContractMethod,
} from "../common";

export declare namespace SellerUtils {
  export type NodeTierStruct = {
    pricePerNode: BigNumberish;
    supply: BigNumberish;
    capacityPerAddress: BigNumberish;
  };

  export type NodeTierStructOutput = [
    pricePerNode: bigint,
    supply: bigint,
    capacityPerAddress: bigint
  ] & { pricePerNode: bigint; supply: bigint; capacityPerAddress: bigint };

  export type UserInfoStruct = { user: AddressLike; nodesAmount: BigNumberish };

  export type UserInfoStructOutput = [user: string, nodesAmount: bigint] & {
    user: string;
    nodesAmount: bigint;
  };
}

export interface SellerInterface extends Interface {
  getFunction(
    nameOrSignature:
      | "boughtCapByUserAtTier"
      | "boughtNodesByUser"
      | "boughtNodesTotal"
      | "boughtSupplyAtTier"
      | "checkAvailableCapPerAddressAtTier"
      | "checkAvailableSupplyPerTier"
      | "checkAvailableSupplyTotal"
      | "collectExtraFunds"
      | "collectFunds"
      | "collected"
      | "collector"
      | "end"
      | "getTiersLength"
      | "getTiersSlice"
      | "getUserInfoSlice"
      | "getUsersLength"
      | "init"
      | "investmentByUser"
      | "merkleLeavesLink"
      | "merkleRoot"
      | "nft"
      | "nodesSoftCap"
      | "nodesSupplyTotal"
      | "owner"
      | "privateSellDuration"
      | "purchaseNodes"
      | "renounceOwnership"
      | "resetCollector"
      | "resetEnd"
      | "resetLeavesLink"
      | "resetNFT"
      | "resetPrivateSelLDuration"
      | "resetRoot"
      | "resetStart"
      | "resetTiers"
      | "resetToken"
      | "setSoftCap"
      | "simulatePurchaseNodes"
      | "start"
      | "tiers"
      | "token"
      | "totalSupply"
      | "transferOwnership"
      | "userClaim"
      | "users"
  ): FunctionFragment;

  getEvent(
    nameOrSignatureOrTopic: "Initialized" | "OwnershipTransferred"
  ): EventFragment;

  encodeFunctionData(
    functionFragment: "boughtCapByUserAtTier",
    values: [AddressLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "boughtNodesByUser",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "boughtNodesTotal",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "boughtSupplyAtTier",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "checkAvailableCapPerAddressAtTier",
    values: [AddressLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "checkAvailableSupplyPerTier",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "checkAvailableSupplyTotal",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "collectExtraFunds",
    values: [AddressLike, AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "collectFunds",
    values: [AddressLike]
  ): string;
  encodeFunctionData(functionFragment: "collected", values?: undefined): string;
  encodeFunctionData(functionFragment: "collector", values?: undefined): string;
  encodeFunctionData(functionFragment: "end", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "getTiersLength",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getTiersSlice",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserInfoSlice",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getUsersLength",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "init",
    values: [
      AddressLike,
      AddressLike,
      BytesLike,
      string,
      BigNumberish,
      BigNumberish,
      BigNumberish,
      SellerUtils.NodeTierStruct[],
      AddressLike,
      AddressLike
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "investmentByUser",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "merkleLeavesLink",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "merkleRoot",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "nft", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "nodesSoftCap",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "nodesSupplyTotal",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "owner", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "privateSellDuration",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "purchaseNodes",
    values: [BigNumberish, BigNumberish, boolean, BigNumberish, BytesLike[]]
  ): string;
  encodeFunctionData(
    functionFragment: "renounceOwnership",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "resetCollector",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "resetEnd",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "resetLeavesLink",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "resetNFT",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "resetPrivateSelLDuration",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "resetRoot",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "resetStart",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "resetTiers",
    values: [SellerUtils.NodeTierStruct[]]
  ): string;
  encodeFunctionData(
    functionFragment: "resetToken",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "setSoftCap",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "simulatePurchaseNodes",
    values: [AddressLike, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(functionFragment: "start", values?: undefined): string;
  encodeFunctionData(functionFragment: "tiers", values: [BigNumberish]): string;
  encodeFunctionData(functionFragment: "token", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "totalSupply",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "transferOwnership",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "userClaim",
    values: [AddressLike]
  ): string;
  encodeFunctionData(functionFragment: "users", values: [BigNumberish]): string;

  decodeFunctionResult(
    functionFragment: "boughtCapByUserAtTier",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "boughtNodesByUser",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "boughtNodesTotal",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "boughtSupplyAtTier",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "checkAvailableCapPerAddressAtTier",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "checkAvailableSupplyPerTier",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "checkAvailableSupplyTotal",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "collectExtraFunds",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "collectFunds",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "collected", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "collector", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "end", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getTiersLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getTiersSlice",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserInfoSlice",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUsersLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "init", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "investmentByUser",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "merkleLeavesLink",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "merkleRoot", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "nft", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "nodesSoftCap",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "nodesSupplyTotal",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "privateSellDuration",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "purchaseNodes",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "renounceOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "resetCollector",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "resetEnd", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "resetLeavesLink",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "resetNFT", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "resetPrivateSelLDuration",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "resetRoot", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "resetStart", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "resetTiers", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "resetToken", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "setSoftCap", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "simulatePurchaseNodes",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "start", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "tiers", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "token", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "totalSupply",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "userClaim", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "users", data: BytesLike): Result;
}

export namespace InitializedEvent {
  export type InputTuple = [version: BigNumberish];
  export type OutputTuple = [version: bigint];
  export interface OutputObject {
    version: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace OwnershipTransferredEvent {
  export type InputTuple = [previousOwner: AddressLike, newOwner: AddressLike];
  export type OutputTuple = [previousOwner: string, newOwner: string];
  export interface OutputObject {
    previousOwner: string;
    newOwner: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export interface Seller extends BaseContract {
  connect(runner?: ContractRunner | null): Seller;
  waitForDeployment(): Promise<this>;

  interface: SellerInterface;

  queryFilter<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;
  queryFilter<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;

  on<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  on<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  once<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  once<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  listeners<TCEvent extends TypedContractEvent>(
    event: TCEvent
  ): Promise<Array<TypedListener<TCEvent>>>;
  listeners(eventName?: string): Promise<Array<Listener>>;
  removeAllListeners<TCEvent extends TypedContractEvent>(
    event?: TCEvent
  ): Promise<this>;

  boughtCapByUserAtTier: TypedContractMethod<
    [arg0: AddressLike, arg1: BigNumberish],
    [bigint],
    "view"
  >;

  boughtNodesByUser: TypedContractMethod<[arg0: AddressLike], [bigint], "view">;

  boughtNodesTotal: TypedContractMethod<[], [bigint], "view">;

  boughtSupplyAtTier: TypedContractMethod<
    [arg0: BigNumberish],
    [bigint],
    "view"
  >;

  checkAvailableCapPerAddressAtTier: TypedContractMethod<
    [user: AddressLike, tierIndex: BigNumberish],
    [bigint],
    "view"
  >;

  checkAvailableSupplyPerTier: TypedContractMethod<
    [tierIndex: BigNumberish],
    [bigint],
    "view"
  >;

  checkAvailableSupplyTotal: TypedContractMethod<[], [bigint], "view">;

  collectExtraFunds: TypedContractMethod<
    [tokenToCollect: AddressLike, recepient: AddressLike],
    [bigint],
    "nonpayable"
  >;

  collectFunds: TypedContractMethod<
    [recepient: AddressLike],
    [void],
    "nonpayable"
  >;

  collected: TypedContractMethod<[], [boolean], "view">;

  collector: TypedContractMethod<[], [string], "view">;

  end: TypedContractMethod<[], [bigint], "view">;

  getTiersLength: TypedContractMethod<[], [bigint], "view">;

  getTiersSlice: TypedContractMethod<
    [offset: BigNumberish, limit: BigNumberish],
    [SellerUtils.NodeTierStructOutput[]],
    "view"
  >;

  getUserInfoSlice: TypedContractMethod<
    [offset: BigNumberish, limit: BigNumberish],
    [SellerUtils.UserInfoStructOutput[]],
    "view"
  >;

  getUsersLength: TypedContractMethod<[], [bigint], "view">;

  init: TypedContractMethod<
    [
      _nft: AddressLike,
      _token: AddressLike,
      _merkleRoot: BytesLike,
      _leavesLink: string,
      _startTimestamp: BigNumberish,
      _endTimestamp: BigNumberish,
      _privateSellDuration: BigNumberish,
      _tiers: SellerUtils.NodeTierStruct[],
      _admin: AddressLike,
      _collector: AddressLike
    ],
    [void],
    "nonpayable"
  >;

  investmentByUser: TypedContractMethod<[arg0: AddressLike], [bigint], "view">;

  merkleLeavesLink: TypedContractMethod<[], [string], "view">;

  merkleRoot: TypedContractMethod<[], [string], "view">;

  nft: TypedContractMethod<[], [string], "view">;

  nodesSoftCap: TypedContractMethod<[], [bigint], "view">;

  nodesSupplyTotal: TypedContractMethod<[], [bigint], "view">;

  owner: TypedContractMethod<[], [string], "view">;

  privateSellDuration: TypedContractMethod<[], [bigint], "view">;

  purchaseNodes: TypedContractMethod<
    [
      startTier: BigNumberish,
      nodesTargetAmount: BigNumberish,
      mustFulfill: boolean,
      maxPurchaseCost: BigNumberish,
      merkleProof: BytesLike[]
    ],
    [void],
    "payable"
  >;

  renounceOwnership: TypedContractMethod<[], [void], "nonpayable">;

  resetCollector: TypedContractMethod<
    [_collector: AddressLike],
    [void],
    "nonpayable"
  >;

  resetEnd: TypedContractMethod<[_end: BigNumberish], [void], "nonpayable">;

  resetLeavesLink: TypedContractMethod<
    [_leavesLink: string],
    [void],
    "nonpayable"
  >;

  resetNFT: TypedContractMethod<[_nft: AddressLike], [void], "nonpayable">;

  resetPrivateSelLDuration: TypedContractMethod<
    [_privateSellDuration: BigNumberish],
    [void],
    "nonpayable"
  >;

  resetRoot: TypedContractMethod<[_root: BytesLike], [void], "nonpayable">;

  resetStart: TypedContractMethod<[_start: BigNumberish], [void], "nonpayable">;

  resetTiers: TypedContractMethod<
    [_tiers: SellerUtils.NodeTierStruct[]],
    [void],
    "nonpayable"
  >;

  resetToken: TypedContractMethod<[_token: AddressLike], [void], "nonpayable">;

  setSoftCap: TypedContractMethod<
    [_nodesSoftCap: BigNumberish],
    [void],
    "nonpayable"
  >;

  simulatePurchaseNodes: TypedContractMethod<
    [
      user: AddressLike,
      startTier: BigNumberish,
      nodesTargetAmount: BigNumberish
    ],
    [
      [boolean, bigint[], bigint, bigint] & {
        fulfilled: boolean;
        buyAmountAtTier: bigint[];
        totalPurchaseCost: bigint;
        totalBought: bigint;
      }
    ],
    "view"
  >;

  start: TypedContractMethod<[], [bigint], "view">;

  tiers: TypedContractMethod<
    [arg0: BigNumberish],
    [
      [bigint, bigint, bigint] & {
        pricePerNode: bigint;
        supply: bigint;
        capacityPerAddress: bigint;
      }
    ],
    "view"
  >;

  token: TypedContractMethod<[], [string], "view">;

  totalSupply: TypedContractMethod<[], [bigint], "view">;

  transferOwnership: TypedContractMethod<
    [newOwner: AddressLike],
    [void],
    "nonpayable"
  >;

  userClaim: TypedContractMethod<
    [recepient: AddressLike],
    [void],
    "nonpayable"
  >;

  users: TypedContractMethod<[arg0: BigNumberish], [string], "view">;

  getFunction<T extends ContractMethod = ContractMethod>(
    key: string | FunctionFragment
  ): T;

  getFunction(
    nameOrSignature: "boughtCapByUserAtTier"
  ): TypedContractMethod<
    [arg0: AddressLike, arg1: BigNumberish],
    [bigint],
    "view"
  >;
  getFunction(
    nameOrSignature: "boughtNodesByUser"
  ): TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
  getFunction(
    nameOrSignature: "boughtNodesTotal"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "boughtSupplyAtTier"
  ): TypedContractMethod<[arg0: BigNumberish], [bigint], "view">;
  getFunction(
    nameOrSignature: "checkAvailableCapPerAddressAtTier"
  ): TypedContractMethod<
    [user: AddressLike, tierIndex: BigNumberish],
    [bigint],
    "view"
  >;
  getFunction(
    nameOrSignature: "checkAvailableSupplyPerTier"
  ): TypedContractMethod<[tierIndex: BigNumberish], [bigint], "view">;
  getFunction(
    nameOrSignature: "checkAvailableSupplyTotal"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "collectExtraFunds"
  ): TypedContractMethod<
    [tokenToCollect: AddressLike, recepient: AddressLike],
    [bigint],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "collectFunds"
  ): TypedContractMethod<[recepient: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "collected"
  ): TypedContractMethod<[], [boolean], "view">;
  getFunction(
    nameOrSignature: "collector"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "end"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "getTiersLength"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "getTiersSlice"
  ): TypedContractMethod<
    [offset: BigNumberish, limit: BigNumberish],
    [SellerUtils.NodeTierStructOutput[]],
    "view"
  >;
  getFunction(
    nameOrSignature: "getUserInfoSlice"
  ): TypedContractMethod<
    [offset: BigNumberish, limit: BigNumberish],
    [SellerUtils.UserInfoStructOutput[]],
    "view"
  >;
  getFunction(
    nameOrSignature: "getUsersLength"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "init"
  ): TypedContractMethod<
    [
      _nft: AddressLike,
      _token: AddressLike,
      _merkleRoot: BytesLike,
      _leavesLink: string,
      _startTimestamp: BigNumberish,
      _endTimestamp: BigNumberish,
      _privateSellDuration: BigNumberish,
      _tiers: SellerUtils.NodeTierStruct[],
      _admin: AddressLike,
      _collector: AddressLike
    ],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "investmentByUser"
  ): TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
  getFunction(
    nameOrSignature: "merkleLeavesLink"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "merkleRoot"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "nft"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "nodesSoftCap"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "nodesSupplyTotal"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "owner"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "privateSellDuration"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "purchaseNodes"
  ): TypedContractMethod<
    [
      startTier: BigNumberish,
      nodesTargetAmount: BigNumberish,
      mustFulfill: boolean,
      maxPurchaseCost: BigNumberish,
      merkleProof: BytesLike[]
    ],
    [void],
    "payable"
  >;
  getFunction(
    nameOrSignature: "renounceOwnership"
  ): TypedContractMethod<[], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "resetCollector"
  ): TypedContractMethod<[_collector: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "resetEnd"
  ): TypedContractMethod<[_end: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "resetLeavesLink"
  ): TypedContractMethod<[_leavesLink: string], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "resetNFT"
  ): TypedContractMethod<[_nft: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "resetPrivateSelLDuration"
  ): TypedContractMethod<
    [_privateSellDuration: BigNumberish],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "resetRoot"
  ): TypedContractMethod<[_root: BytesLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "resetStart"
  ): TypedContractMethod<[_start: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "resetTiers"
  ): TypedContractMethod<
    [_tiers: SellerUtils.NodeTierStruct[]],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "resetToken"
  ): TypedContractMethod<[_token: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "setSoftCap"
  ): TypedContractMethod<[_nodesSoftCap: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "simulatePurchaseNodes"
  ): TypedContractMethod<
    [
      user: AddressLike,
      startTier: BigNumberish,
      nodesTargetAmount: BigNumberish
    ],
    [
      [boolean, bigint[], bigint, bigint] & {
        fulfilled: boolean;
        buyAmountAtTier: bigint[];
        totalPurchaseCost: bigint;
        totalBought: bigint;
      }
    ],
    "view"
  >;
  getFunction(
    nameOrSignature: "start"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "tiers"
  ): TypedContractMethod<
    [arg0: BigNumberish],
    [
      [bigint, bigint, bigint] & {
        pricePerNode: bigint;
        supply: bigint;
        capacityPerAddress: bigint;
      }
    ],
    "view"
  >;
  getFunction(
    nameOrSignature: "token"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "totalSupply"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "transferOwnership"
  ): TypedContractMethod<[newOwner: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "userClaim"
  ): TypedContractMethod<[recepient: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "users"
  ): TypedContractMethod<[arg0: BigNumberish], [string], "view">;

  getEvent(
    key: "Initialized"
  ): TypedContractEvent<
    InitializedEvent.InputTuple,
    InitializedEvent.OutputTuple,
    InitializedEvent.OutputObject
  >;
  getEvent(
    key: "OwnershipTransferred"
  ): TypedContractEvent<
    OwnershipTransferredEvent.InputTuple,
    OwnershipTransferredEvent.OutputTuple,
    OwnershipTransferredEvent.OutputObject
  >;

  filters: {
    "Initialized(uint8)": TypedContractEvent<
      InitializedEvent.InputTuple,
      InitializedEvent.OutputTuple,
      InitializedEvent.OutputObject
    >;
    Initialized: TypedContractEvent<
      InitializedEvent.InputTuple,
      InitializedEvent.OutputTuple,
      InitializedEvent.OutputObject
    >;

    "OwnershipTransferred(address,address)": TypedContractEvent<
      OwnershipTransferredEvent.InputTuple,
      OwnershipTransferredEvent.OutputTuple,
      OwnershipTransferredEvent.OutputObject
    >;
    OwnershipTransferred: TypedContractEvent<
      OwnershipTransferredEvent.InputTuple,
      OwnershipTransferredEvent.OutputTuple,
      OwnershipTransferredEvent.OutputObject
    >;
  };
}
